import ij.*;
import ij.plugin.filter.PlugInFilter;
import ij.process.*;
import ij.gui.*;
import java.awt.event.*;

	/**
	 *	This plugin listens for mouse clicks generated by the current image and
	 *	goes to the next frame in the stack.
	*/
	public class Click_Forward_ implements PlugInFilter, MouseListener {
		ImagePlus imp;

	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_ALL+STACK_REQUIRED+NO_CHANGES;
	}

	public void run(ImageProcessor ip) {
		ImageWindow win = imp.getWindow();
		ImageCanvas canvas = win.getCanvas();
		canvas.addMouseListener(this);
	}
	
	public void mouseReleased(MouseEvent e) {
  		imp.setSlice(imp.getCurrentSlice()+1);
	}
	
	public void mousePressed(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
}


